//
//  MyController.m
//  SuperTuxKart
//
//  Created by Florian Bethke on 29.03.07.
//  Copyright Florian Bethke 2007. All rights reserved.
//

#import "MyController.h"

@implementation MyController

- (void)awakeFromNib
{
	[NSApp setDelegate: self];
}

- (void)applicationDidFinishLaunching:(NSNotification*)notification
{
	[resMenu removeAllItems];
	
	CGDirectDisplayID displayID = CGMainDisplayID();
	NSArray *resolutions = (NSArray *)CGDisplayAvailableModes(displayID);
	NSMutableArray *width	= [NSMutableArray array];
	NSMutableArray *heigth = [NSMutableArray array];
	
	int i, j;
	bool skip;
	for(i=0;i<[resolutions count];i++){
		skip = false;
		for(j=0;j<[width count];j++){
			if(	[[heigth objectAtIndex:j] isEqualToNumber:[[resolutions objectAtIndex:i] objectForKey:@"Height"]] &&
				[[width  objectAtIndex:j] isEqualToNumber:[[resolutions objectAtIndex:i] objectForKey:@"Width"]]){
				skip = true;
			}
		}
		if(!([[[resolutions objectAtIndex:i] objectForKey:@"UsableForDesktopGUI"] isEqualToNumber:[NSNumber numberWithInt:0]])) {
			if(!skip){
				[heigth addObject:[[resolutions objectAtIndex:i] objectForKey:@"Height"]];
				[width addObject:[[resolutions objectAtIndex:i] objectForKey:@"Width"]];
				NSString *str = [NSString stringWithFormat:@"%@x%@", [[width lastObject] stringValue], [[heigth lastObject] stringValue]];
				[resMenu addItemWithTitle:str];
			}
		}
	}
	
	if([[NSFileManager defaultManager] fileExistsAtPath:@"/System/Library/Frameworks/OpenAL.framework"])
		openal = true;
	else if([[NSFileManager defaultManager] fileExistsAtPath:@"/Library/Frameworks/OpenAL.framework"])
		openal = true;
	else if([[NSFileManager defaultManager] fileExistsAtPath:[@"~/Library/Frameworks/OpenAL.framework" stringByExpandingTildeInPath]])
		openal = true;
}

- (IBAction)launch:(id)sender
{
	NSMutableString *theString;
	if(openal){
		theString = [NSMutableString stringWithFormat:@"cd %@/Contents/Resources/bin && ./supertuxkart -s ", [[NSBundle mainBundle] bundlePath]];
		NSLog(@"Using OpenAL!");
	}
	else{
		theString = [NSMutableString stringWithFormat:@"cd %@/Contents/Resources/bin && ./supertuxkartPLIB -s ", [[NSBundle mainBundle] bundlePath]];
		NSAlert *alert = [NSAlert alertWithMessageText:@"OpenAL framework not found" defaultButton:@"OK" alternateButton:nil otherButton:nil informativeTextWithFormat:@"Using PLIB for Sound Output. Install OpenAL for a better sound quality."];
		[alert runModal];
	}
	[theString appendString:[[resMenu selectedItem] title]];
	[theString appendString:@" "];
	if([fullscreenSwitch state])
		[theString appendString:@"--fullscreen"];
	else
		[theString appendString:@"--windowed"];

	if(running){
		NSAlert *myAlert = [NSAlert alertWithMessageText:@"SuperTuxKart is already running!" defaultButton:@"OK" alternateButton:nil otherButton:nil informativeTextWithFormat:[NSString string]];
		[myAlert runModal];
	}
	else
		[NSThread detachNewThreadSelector:@selector(startSTK:) toTarget:self withObject:theString];
}

- (IBAction)deleteConfig:(id)sender
{
	NSString *theString = [@"~/.supertuxkart" stringByExpandingTildeInPath];
	NSString *rmString  = [NSString stringWithFormat:@"rm -R %@", theString];
	system([rmString cString]);
}

- (void)startSTK:(NSString *)theString
{
    NSAutoreleasePool *pool=[[NSAutoreleasePool alloc] init];

	running = true;
	system([theString cString]);
	running = false;
	
	[pool release]; 
}

@end
